#pragma once

class CIdbFile
{
public:
	CIdbFile(void);
	~CIdbFile(void);

public:
	// f[^͈
	CString m_period;
	// _EN
	CString m_downlink;
	// lbg[NIDiUNIT IDʂSj
	int	m_networkid;
	// jbgIDiUNIT IDʂSj
	int m_rsuid;
	// ZT[ID
	int m_sensorid;
	// ^C[
	CString m_timezero;
	// ^C[(XML)
	CString m_timezeroXML;
	// QC
	int m_gain;
	// Tv[g
	double m_samplerate;
	// JbgItg
	int m_cutoff;
	// ۑpX
	CString m_path;
	// Bias Co Eff
	int m_biascoeff;
	// Sensor Co Sys
	CString m_sensorcosys;
	// Data Co Sys
	CString m_datacosys;
	// Data Quality
	CString m_dataquality;
	// ISS Config
	CString m_issconfig;
	// XP[t@N^[
	int m_scalefactor;
	// Rg
	CString m_comment;
	// PԖ̃t@CۑGA
	CStringArray m_File;
	// JeS
	CString m_sCategory;
	// v
	CString m_sMeasurementKind;
	// idbt@CpX
	CString m_sIdbPath;
	// f[^
	int m_nDataType;

private:
	// X^[g^CYYYYiNjMM()DD()SSSSSSSSi~bj
	CString	m_starttime;
	// ZT[IDX
	int	m_SensorIdx;
	// IDBt@Cǂݍ݃GA
	CStringArray	m_Data;
// 2009/07/07 Version 3.02 appended by m.hama ->
	// XMLt@Cǂݍ݃GA
	CStringArray	m_XmlData;
// <- 2009/07/07 Version 3.02 appended by m.hama

public:
	// f[^͈
	void SetPeriod(LPCSTR str)	{ m_period = str; }
	// _EN
	void SetDownlink(LPCSTR str)	{ m_downlink = str; }
	// lbg[NIDiUNIT IDʂSj
	void SetNetworkid(int id)	{m_networkid = id; }
	// jbgIDiUNIT IDʂSj
	void SetRsuId(int id)	{ m_rsuid = id; }
	// ZT[ID
	void SetSensorId(int id)	{ m_sensorid = id; }
	// ^C[
	void SetTimeZero(LPCSTR str)	{ m_timezero = str; }
	// ^C[
	void SetTimeZeroXML(LPCSTR str)	{ m_timezeroXML = str; }
	// QC
	void SetGain(int gain)	{ m_gain = gain; }
	// Tv[g
	void SetSampleRate(double f)	{ m_samplerate = f; }
	// JbgItg
	void SetCutoff(int c)	{ m_cutoff = c; }
	// ۑpX
	void SetPath(LPCSTR str)	{ m_path = str; }
	// Bias Co Eff
	void SetBiascoeff(int c)	{ m_biascoeff = c; }
	// Sensor Co Sys
	void SetSensorcosys(LPCSTR str)	{ m_sensorcosys = str; }
	// Data Co Sys
	void SetDatacosys(LPCSTR str)	{ m_datacosys = str; }
	// Data Quality
	void SetDataquality(LPCSTR str)	{ m_dataquality = str; }
	// ISS Config
	void SetIssconfig(LPCSTR str)	{ m_issconfig = str; }
	// XP[t@N^[
	void SetScalefactor(int sf)	{ m_scalefactor = sf; }
	// Rg
	void SetComment(LPCSTR str)	{ m_comment = str; }
	// JeS
	void SetCategory(LPCSTR str) { m_sCategory = str; }
	// v
	void SetMeasurementKind(LPCSTR str) { m_sMeasurementKind = str; }

	// X^[g^CYYYYiNjMM()DD()SSSSSSSSi~bj
	void SetStartTime(long YY, long MM, long DD, long mS)	{ m_starttime.Format("%04d%02d%02d%08d", YY, MM, DD, mS); }
	// ZT[IDX
	void SetSensorIdx(int idx) { m_SensorIdx = idx; }
	// 1Ԗ̃t@CۑGA
	void AddFile(LPCSTR str)	{ m_File.Add(str); }
	// IDBt@C
	bool Write(LPCSTR name);
	// IDBt@Cǂݍ
	bool Read(LPCSTR path);
	bool Read2(LPCSTR fname);
	// IDBt@C擾
	bool GetFname(LPCSTR path, CString& fname);
private:
	// IDBt@Cǂݍ
	bool GetIdbFileData(LPCSTR path);
	// f[^Zbg
	void SetIdbFileData(void);
	// t@Cf[^w荀ڂ擾
	bool GetData(LPCSTR itemStr, CString &oDat);
	// t@Cf[^畡̎w荀ڂ擾
	void GetData(LPCSTR itemStr, CStringArray &oDat);
	// t@Cf[^w荀ڂ擾
	bool GetDataFromIdb(LPCSTR dat, LPCSTR itemStr, CString &oDat);
	// oCif[^t@Cۑ`FbN
	void CheckBinDataPath(LPCTSTR pIdbFilePath);
	// MMAXMLt@C
	void WriteXmlMma(CStdioFile &fp, LPCSTR name);
	// MMEXMLt@C
	void WriteXmlMme(CStdioFile &fp, LPCSTR name);
	// ASUXMLt@C
	void WriteXmlAsu(CStdioFile &fp, LPCSTR name);

public:
	bool WriteXml(LPCSTR name, int nDataType);
// 2009/07/07 Version 3.02 appended by m.hama ->
	bool GetXmlFileData(LPCSTR path);
	bool WriteXml2(LPCSTR name);
// <- 2009/07/07 Version 3.02 appended by m.hama

	// NA
	void DelAll(void);
};
